# Python Handout

[![PyPI](https://img.shields.io/pypi/v/handout.svg)](https://pypi.python.org/pypi/handout/#history)

Turn Python scripts into handouts with Markdown comments and inline figures. An
alternative to Jupyter notebooks without hidden state that supports any text
editor.

| Code | Handout |
| ---- | ------- |
| ![Code](https://i.imgur.com/ROEs3I3.png) | ![Handout](https://i.imgur.com/nldbrQw.png) |

## Getting started

You use Python Handout as a library inside a normal Python program:

1. Install via `pip3 install -U handout`.
2. Run your script via `python3 script.py`. (You can start with the `example.py`
   from the repository.)
3. Open `output/index.html` in your browser to view the result.
4. Iterate and refresh your browser.

## Features

Create the handout via `doc = handout.Handout(outdir)` to access these features:

| Feature | Example |
| ------- | ------- |
| Add [Markdown text][markdown] as multi-line comments. | `"""Markdown text"""` |
| Add print messages. | `doc.add_text('text:', variable)` |
| Add matplotlib figures. | `doc.add_figure(fig, width=1.0)` |
| Add custom HTML. | `doc.add_html(string)` |
| Insert added items and save to `<outdir>/index.html`. | `doc.show()` |

[markdown]: https://commonmark.org/help/

## Questions

Feel free to create an issue on Github.
